with System;
with Windows;
package Game.Screen is

	subtype Handle is Windows.HANDLE;

	Input: constant HANDLE := Windows.GetStdHandle(Windows.STD_INPUT_HANDLE);
	Output: constant HANDLE := Windows.GetStdHandle(Windows.STD_OUTPUT_HANDLE);

	procedure Set_Title(Text: in String);
	procedure Set_Window_Size_80x25;
	
	function New_Screen return Handle;
	procedure Present(Screen: Handle);
	procedure Dispose(Screen: Handle);
	
	procedure Clear(Screen: Handle);
	procedure Write(Screen: Handle; X, Y: Integer; Text: in String; Attribute: Windows.WORD);

	type Screen_Buffer is array(0..24, 0..79) of aliased Windows.CHAR_INFO;
	procedure Clear(Buffer: in out Screen_Buffer);
	procedure Write(Buffer: in out Screen_Buffer; X, Y: Integer; Text: in String; Attribute: Windows.WORD);
	procedure Write_All(Screen: Handle; Buffer: Screen_Buffer);

	subtype Event is Windows.INPUT_RECORD;

	function Has_Events(Input: in HANDLE) return Boolean;
	function Get_Event(Input: in HANDLE) return Event;
	function Is_Lost_Focus(Message: in Event) return Boolean;
	function Is_Escape_Press(Message: in Event) return Boolean;

end Game.Screen;
